#!/usr/bin/python
# -*- coding: utf-8 -*-
import pythymio as pt






state['time'] = 0
state['plan'] = []

def av(centimeters):
    duration = 23 # for one centimeter
    state['plan'].append('forward', centimeters * duration)
    state['plan'].append('stop', 0)

def tg(degrees):
    duration = 207 / 360.0 # for one degree
    state['plan'].append('left', degrees * duration)
    state['plan'].append('stop', 0)

def td(degrees):
    duration = 207 / 360.0 # for one degree
    state['plan'].append('right', degrees * duration)
    state['plan'].append('stop', 0)

def reset():
    state['time'] = 0
    state['plan'] = []

def plan():
    for i in range(6):
        av(5)
        tg(60)

custom = pt.customEvents('colors', 'sound')

with pt.thymio(['buttons', 'prox'], custom) as Thym:

    def play(action):
        if action == 'blue':
            Thym.send_event('become.blue')
        if action == 'green':
            Thym.send_event('become.green')
        if action == 'red':
            Thym.send_event('become.red')
        if action == 'left':
            Thym.set('motor.left.target', -150)
            Thym.set('motor.right.target', 150)
        if action == 'stop':
            Thym.set('motor.left.target', 0)
            Thym.set('motor.right.target', 0)
        if action == 'right':
            Thym.set('motor.left.target', 150)
            Thym.set('motor.right.target', -150)
        if action == 'foward':
            Thym.set('motor.left.target', 150)
            Thym.set('motor.right.target', 150)

    def react(num, evt, data):
        if evt == "fwd.buttons":
            state['time'] += 1
            if len(state['plan']) > 0:
                action, duration = state['plan'][0]
                if state['time'] == 1:
                    play(action)
                if state['time'] >= duration:
                    state['time'] = 0
                    state['plan'].pop(0)

        if evt == 'fwd.prox':
            if max(data[0:5]) > 1500:
                # obstacle devant
                reset() # will happen at 10Hz while escaping…
                tg(120)
                plan()


    plan()

    Thym.loop(react)
